From e8eb3e87c563bd9b5cdad6b138325bd8ad683d5e Mon Sep 17 00:00:00 2001
From: Min Xu <min.xu[A.T]min-info[D.O.T]net>
Date: Wed, 11 Sep 2013 15:35:04 -1000
Subject: [PATCH 5/6] The condition for uart idle is fixed to:

1) There has been no new data since last check

2) There are no req_ctx currently pending to be transmitted to USB

3) We did NOT just got a reset and waiting for ATR (saw an ATR split in two
different req_ctx prior, presumably flush decided to send req_ctx after ATR
but got a new character just before sent).  If we did get a RESET, let
original logic decide to send the req_ctx -- presumably when ATR data is
fully received
---
 firmware/src/simtrace/iso7816_uart.c |    5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

diff --git a/firmware/src/simtrace/iso7816_uart.c b/firmware/src/simtrace/iso7816_uart.c
index 39072a0..7c8f04c 100644
--- a/firmware/src/simtrace/iso7816_uart.c
+++ b/firmware/src/simtrace/iso7816_uart.c
@@ -588,7 +588,10 @@ void iso_uart_flush(void) {
 void iso_uart_idleflush(void) {
 	static struct req_ctx *last_req = NULL;
 	static u_int16_t last_len = 0;
-	if (last_req == isoh.rctx || last_len == isoh.rctx->tot_len) {
+	if (last_req == isoh.rctx &&
+        	last_len == isoh.rctx->tot_len &&
+		req_ctx_count(RCTX_STATE_UDP_EP2_PENDING) == 0 &&
+		(isoh.sh.flags & SIMTRACE_FLAG_ATR) == 0) {
 		send_rctx(&isoh);
 	}
 	last_req = isoh.rctx;
-- 
1.7.9.5

